package extensions.awt;
import java.awt.*;

/**
 * Allows delegation of action events.  Implement
 * to create handlers and handler-adapters.
 *
 * @see extensions.awt.FrameExtended#action
 * @see extensions.awt.MenuItemAction
 * @see extensions.awt.ButtonAction
 * @version 1.0.2
 * @author John Webster Small
 */
public interface ActionProtocol
{

  /** An action event has occurred,
    * perform required action.
    * @param forward the component forwarding action event
    * @param evt the event that caused the action
    * @param what the action
    */
  public void action(Component forward, Event evt, Object what);
}
