package extensions.awt;
import java.awt.*;

/** Constructs a ChoiceCardPanel.  Only
  * add(name,comp)!
  * @version 1.0.2
  * @author John Webster Small
  */
public class ChoiceCardPanel extends Panel
  implements ActionProtocol
{
  private Choice pageNames;
  private Panel pages;

  /** Construct ChoiceCardPanel. */
  public ChoiceCardPanel()
  {
    setLayout(new BorderLayout());
    pageNames = new ChoiceAction(this);
    super.add("North",pageNames);
    pages = new Panel();
    pages.setLayout(new CardLayout());
    super.add("Center",pages);
    validate();
  }

  /** Add named component.
    * @param name name of component which appears in Choice
    * @param comp component to appear when chosen
    */
  public Component add(String name, Component comp)
  {
    pageNames.addItem(name);
    pages.add(name,comp);
    return comp;
  }

  /** Switch to named card.
    * @see java.awt.CardLayout#show
    */
  public void show(String name)
  {
    ((CardLayout)pages.getLayout()).show(pages,name);
  }

  /** @see extensions.awt.ActionProtocol */
  public final void action
    (Component forward, Event evt, Object what)
    { show((String)what); }
}
