package extensions.awt;
import java.awt.*;

/**
 * Label-TextField pair.
 * @version 1.0.2
 * @author John Webster Small
 */
public class TextFieldActionPanel extends Panel
{
  TextFieldAction field;
  String name;

  /**
    * Construct TextFieldPanel.
    * @param name name of field
    * @param ap action to be performed, i.e. run()
    */
  public TextFieldActionPanel(String name, ActionProtocol ap)
  {
    this.name = name;
    field = new TextFieldAction(ap);
    add(new Label(name));
    add(field);
  }

  /**
    * Construct TextFieldPanel.
    * @param name name of field
    * @param cols width of field
    * @param ap action to be performed, i.e. run()
    */
  public TextFieldActionPanel
    (String name, int cols, ActionProtocol ap)
  {
    this.name = name;
    field = new TextFieldAction(cols,ap);
    add(new Label(name));
    add(field);
  }

  /**
    * Construct TextFieldPanel.
    * @param name name of field
    * @param text initial field contents
    * @param ap action to be performed, i.e. run()
    */
  public TextFieldActionPanel
    (String name, String text, ActionProtocol ap)
  {
    this.name = name;
    field = new TextFieldAction(text,ap);
    add(new Label(name));
    add(field);
  }

  /**
    * Construct TextFieldPanel.
    * @param name name of field
    * @param text initial field contents
    * @param cols width of field
    * @param ap action to be performed, i.e. run()
    */
  public TextFieldActionPanel
    (String name, String text, int cols, ActionProtocol ap)
  {
    this.name = name;
    field = new TextFieldAction(text,cols,ap);
    add(new Label(name));
    add(field);
  }

  /** return name of field. */
  public String getName() { return name; }

  /**
    * Fetch field for direct manipulation.
    * @return returns TextField allows direct control
    */
  public TextField getTextField() { return field; }
}
