package extensions.awt;
import java.awt.*;

/**
  * Basic viewing frame.
  * @version 1.0.2
  * @author John Webster Small
  */
public class TextFrame extends FrameExtended
{

  private TextArea ta;

  /** Default frame rows. */
  public static int ROWS = 15;

  /** Default frame columns. */
  public static int COLS = 60;

  /**
    * Construct frame for viewing text.
    * @param title frame's title
    * @param text text to be viewed
    * @param rows opens window with this many rows
    * @param cols opens window with this many columns
    */
  public TextFrame(String title, String text, int rows, int cols)
  {
    super(title);
    MenuBar mb = new MenuBar();
    Menu m = new Menu("File");
    m.add(new MenuItemAction("Exit",destroyAdapter()));
    m.add(new MenuItemAction("Exit All",destroyFramesAdapter()));
    mb.add(m);
    m = new Menu("Windows");
    m.add(new MenuItemAction("List ...",pickFrameAdapter()));
    m.add(new MenuItemAction("Cascade",cascadeFramesAdapter()));
    mb.add(m);
    setMenuBar(mb);
    if (text == null)
      ta = new TextArea(rows,cols);
    else
      ta = new TextArea(text,rows,cols); 
    ta.setEditable(false);
    add("Center",ta);
    pack();
    show();
  }

  /**
    * Construct frame for viewing text.
    * @param title frame's title
    * @param text text to be viewed
    */
  public TextFrame(String title, String text)
    { this(title,text,ROWS,COLS); }

  /**
    * Construct frame for viewing text.
    * @param title frame's title
    */
  public TextFrame(String title)
    { this(title,null); }

  /** Return unlying TextArea. */
  public TextArea getTextArea()
    { return ta; }

}
