package extensions.util;
import java.util.*;

/**
  * Smalltalk styled "do" enumerator
  * @version 1.0.2
  * @author John Webster Small
  */
public abstract class Apply
{
  private Enumeration subjects;

  /** Call from your overridden constructor. */
  protected void doIt()
  {
    while (subjects.hasMoreElements())
      apply(subjects.nextElement());
  }

  /** Override to define applicator "do" block. */
  protected abstract void apply(Object subject);

  /** Make application to subjects.
    * @param subjects objects of application
    */
  public Apply(Enumeration subjects)
    { this.subjects = subjects; }
}
