package extensions.util;
import java.util.*;

/**
  * Smalltalk styled "detect" enumerator
  * @version 1.0.2
  * @author John Webster Small
  */
public abstract class Detect
{

  /** Construct Detect enumerator. */
  public Detect() {}

  /** Override to define "detect" block. */
  protected abstract boolean found(Object suspects);

  /** Investigate suspects.
    * @param suspects objects of suspicion
    */
  public Object detect(Enumeration suspects)
  {
    Object g;
    while (suspects.hasMoreElements())
      if (found(g = suspects.nextElement()))
        return g;
    return null;
  }
}
