package extensions.util;
import java.util.*;

/**
  * Issue and recycle IDs.
  * @version 1.0.2
  * @author John Webster Small
  * @see extensions.util.Instances
  */
public class IDs
{
  private Vector recycled;
  private int highest;

  /** Construct ID generator. */
  public IDs()
  {
    recycled = new Vector();
    highest = 0;
  }

  /** Issue next ID in sequence from pool of
    * all available for issue IDs.
    */
  public int issue()
  {
    if (recycled.size() == 0)
      return ++highest;
    Integer id = (Integer) recycled.elementAt(0);
    recycled.removeElementAt(0);
    return id.intValue();
  }

  /** ID is no longer needed so recycle for
    * subsequent reissue.
    * @param id ID no longer needed
    */
  public void recycle(int id)
  {
    for (int i = 0; i < recycled.size(); i++)
      if (id < ((Integer)recycled.elementAt(i)).intValue())  {
        recycled.insertElementAt(new Integer(id),i);
        return;
      }
    recycled.addElement(new Integer(id));
  }
}
